TARGET = libmodplug.a

CFLAGS += -I. -Ilibmodplug 

# Flags from libmodplug's makefile
CFLAGS += -D_REENTRANT -MD -MP -DHAVE_CONFIG_H -g -O2 -fno-exceptions -ffast-math -fPIC -DPID

AR   = $(PREFIX)ar
CC   = $(PREFIX)gcc
CXX  = $(PREFIX)g++

HEADERS = config.h modplug.h

LIBOBJS = fastmix.o mmcmp.o modplug.o snd_dsp.o \
          sndfile.o snd_flt.o snd_fx.o sndmix.o tables.o \
          load_669.o load_amf.o load_ams.o load_dbm.o load_dmf.o load_dsm.o \
          load_far.o load_it.o load_j2b.o load_mdl.o load_med.o load_mod.o \
          load_mt2.o load_mtm.o load_okt.o load_psm.o load_ptm.o load_s3m.o \
          load_stm.o load_ult.o load_umx.o load_wav.o load_xm.o

%.o: %.cpp
	$(CXX) -c $(CFLAGS) $< -o $@

all: $(TARGET)

$(TARGET): $(LIBOBJS)
	$(AR) rs $(TARGET) $(LIBOBJS)

clean:
	rm -rf $(LIBOBJS) $(TARGET)

config.o:
