#ifndef _FIFO_H_
#define _FIFO_H_

class Fifo
{
public:
	Fifo(int size);
	~Fifo();
	int Write(void *src, int size);
	int Read(void *src, int size);
	int Read16(void *dst, int size, int scale = 0x10000);
protected:
	unsigned char *buffer;
	unsigned char *ptr;
	int size;
};

class BlockFifo
{
public:
	BlockFifo(int bsize, int bcount);
	~BlockFifo();
	int Write(void *src, int blocks);
	int Read(void *src, int blocks, bool peek = false);
	int Read16(void *dst, int size, int scale = 0x10000);

	int LeftToRead();
	int LeftToWrite();

	void *ExamineNextBlock() { return (void *)readptr; }

	void *WriteTarget(int blocks);
	void *ReadTarget(int blocks);

	void Reset();

protected:
	unsigned char *readptr;
	unsigned char *writeptr;
	int blocksize;
	int blockcount;
	unsigned char *buffer;
	int wrap;

};

#endif
