#ifndef FILELIST_H
#define FILELIST_H

#include "Files.h"


class FileList : public IFileList
{
public:

	FileList(char *source, int (*fcb)(const char *) = NULL);
	virtual ~FileList();

	virtual int Read(int index, char *dest, int offset, int length);
	virtual const char *GetFileName(int index);
	virtual std::vector<FileRef> &GetNames();
	virtual int Enter(int index);

	int Size() { return fnames.size(); }

	virtual void SetFilterFunc(int (*fcb)(const char *))
	{
		printf("Setting %p %p\n", filter_cb, &filter_cb);
		filter_cb = fcb;
	}

protected:

	int (*filter_cb)(const char *);

	std::vector<char*> fnames;
	std::vector<FileRef> filerefs;

	bool dirty;
	char curdir[256];

	void Enter(char *dirname);

};

#endif
