#ifndef PLUGIN_H
#define PLUGIN_H

struct sound_plugin
{

	char *plugname;

	int (*init_data)(char *name, void *data, int size);
	int (*init_file)(char *filename);
	int (*request_format)(int freq, int chn);

	int (*set_position)(int seconds, int subtune);

	int (*fill_buffer)(signed short *dest, int len);

	int (*can_handle)(const char *name);

	int (*close)();

	// Format of current stream
	int freq;
	unsigned char channels;

	// Data on current song - invalid before init_file has been called
	char *name;
	char *artist;
	char *copyright;
	char *format;
	int length;
	int subtunes;
	int tune;

};

#endif

