/*  Copyright 2006 Jonas Minnberg

    This file is part of OldPlay - a portable, multiformat musicplayer.

    OldPlay is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    OldPlay is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with OldPlay; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef _PLAYERAPP_H_
#define _PLAYERAPP_H_

#include "config.h"

class MusicPlayer;
class PlayList;
class FileList;
class ZipFileList;
class SongInfoPane;
class LedControl;
class Equalizer;

class PlayerApp
{
public:
	MusicPlayer *music_player;
	bool repeat;
	bool shuffle;
	bool cpu_scaling;
	bool playing;
	PlayList *play_list;
	FileList *file_list;
	ZipFileList *zip_list;

	bool PlaySong(IFileList *list, int index);
	void RenderEq();
	void Layout();
	void InitSettings(char *fname);

	bool Update();
	void Render();
	bool HandleKey(int key);

	PlayerApp(char *fname);
	~PlayerApp();

	SongInfoPane *songInfo;
	LedControl *lcd;
	Equalizer *eq ;
	ListPane *pane;

	Config screen_cfg;
	Config config;

	int hmargin;
	int vmargin;
	int sep;
	Screen::DisplaySettings settings;

};

#endif
